# -*- coding: UTF-8 -*-
'''
Created on 20.09.2012

@author: Chaynikov Vladimir
'''

import atexit
import fnmatch
import os
import signal
import startReader
import sys
import tempfile
import time
from artix.common import servicelock
from common import config, logger
from unload.node.cash import nodeGetter
from unload.service.reader import Reader

node = nodeGetter.getNodes()[0]
log = logger.getUnloadLogger("Node", node.id)

log.info(u'Запуск сервиса выгрузки продаж')
lockFile = os.path.normpath('%s/locks/lockArtixUnloadService' % tempfile.gettempdir())
srvLock = servicelock.ServiceLock(lockFile, log)
atexit.register(srvLock.unlock)
signal.signal(signal.SIGTERM, srvLock.unlock)

reader = Reader()

srvLock.lock()


def findFile(directory, pattern):
    if os.path.exists(directory):
        for file in os.listdir(directory):
            if fnmatch.fnmatch(file.lower(), pattern.lower()):
                return os.path.join(directory, file)
    return None


timeUnloadCurrentSales = 0
timeFindRequest = 0
timeNodeReread = 0
timeoutNodeReread = 300  # таймаут перечитывания настроек


def readPropertiesFromConfig():
    unloadCurrentSalesInterval = config.getInt('UNLOAD', 'unloadCurrentSalesInterval', 0)
    unloadSalesInterval = config.getInt('UNLOAD', 'unloadSalesInterval', 10)
    closedShiftsByFileFlag = config.getInt('UNLOAD', 'closedShiftsByFileFlag', 0)
    workDirectory = config.getString('main', 'workDirectory', '/linuxcash/cash/data/tmp/exchangers')
    return unloadCurrentSalesInterval, unloadSalesInterval, closedShiftsByFileFlag, workDirectory


unloadCurrentSalesInterval, unloadSalesInterval, closedShiftsByFileFlag, workDirectory = readPropertiesFromConfig()
while True:
    if timeNodeReread == 0 or (time.time() - timeoutNodeReread) > timeNodeReread:
        timeNodeReread = time.time()
        node = nodeGetter.getNodes()[0]
        unloadCurrentSalesInterval, unloadSalesInterval, closedShiftsByFileFlag, workDirectory = readPropertiesFromConfig()
    if unloadCurrentSalesInterval != 0:
        if timeUnloadCurrentSales == 0 or (time.time() - unloadCurrentSalesInterval) > timeUnloadCurrentSales:
            timeUnloadCurrentSales = time.time()
            startReader.unload(reader, node, log, workDirectory, closedShifts=1)
    if timeFindRequest == 0 or (time.time() - unloadSalesInterval) > timeFindRequest:
        timeFindRequest = time.time()
        for converter in node.cashes[0].converters:
            if converter.flag:
                request = findFile(os.path.dirname(converter.flag), os.path.basename(converter.flag))
                if request:
                    startReader.unload(reader, node, log, workDirectory, request=request, converterName=converter.name, closedShifts=closedShiftsByFileFlag)
    if not findFile('%s/locks/' % tempfile.gettempdir(), 'lockArtixUnloadNowForShop*'):
        if findFile(workDirectory+'/%s/unload' % node.id, 'ready'):
            reader.send(node, workDirectory)
        if findFile(workDirectory+'/%s/unload' % node.id, 'readyOnline'):
            reader.send(node, workDirectory, closedShifts=1)
    time.sleep(3)
